/*
 * File         : test7.java
 * Author       : Guansong Zhang
 * Created      : Wed Jan 14 11:18:22 1998
 * Revision     : $Revision: 1.4 $
 * Updated      : $Date: 1998/09/29 19:48:28 $
 * Copyright: Northeast Parallel Architectures Center
 *            at Syracuse University 1998
 */

//   !hpf$ processors p(3, 2)
//
//   !hpf$ template t(24, 8)
//   !hpf$ distribute t(block, cyclic) onto p
//
//   integer a(8, 4, 10)
//
//   !hpf$ align a(i, *, k) with t(4 + 2 * k, i)
//
//   !hpf$ processors q(2, 3)
//
//   !hpf$ template s(10, 4)
//   !hpf$ distribute s(block, block) onto q
//
//   integer b(6, 4, 12)
//   !hpf$ align b(i, j, *) with s(8 - i, j)
//
//   integer u(6), v(12)
//   !hpf$ align u(i) with b(i, *, *)
//
//   integer i, j, k
//
//   do i = 1, 8
//     do j = 1, 4
//       do k = 1, 10
//         a(i, j, k) = 100 * (i - 1) + 10 * (j - 1) + (k - 1)
//       enddo
//     enddo
//   enddo
//
//   do i = 1, 6
//     u(i) = 1 + mod((i - 1) * 5, 8)
//   enddo
//
//   do k = 1, 12
//     v(k) = 1 + (k - 1) / 2 + 1
//   enddo
//
//   b = a(u, :, v)
//
//   do i = 1, 6
//     do j = 1, 4
//       do k = 1, 12
//         print "(i3, i3, i3, i10)", i - 1, j - 1, k - 1, b(i, j, k)
//       enddo
//     enddo
//   enddo
//
// end

import hpjava.spmd.*;
import hpjava.spmd.adlib.*;
import hpjava.lang.*;

class test7 {
  static SpmdEnv spmd;
  static Procs2 p,q;
  static CyclicRange x;
  static Range z,r;
  static BlockRange s;
  static Array3dcdI a;
  static Array3ddcI b;
  static Index ix,iz,ir;
  static int    y,t,iy,it;

  public static void main(String argv[]) {
    spmd = new SpmdEnv(argv);

    p=new Procs2(3,2);

    x = new CyclicRange (8, p.dim(0));
    // y = new Range(4);
	y = 4; //???
    z = new BlockRange(24, p.dim(0)).subrng(10,5,2);

    a = new Array3dcdI(p, x, y, z);

    q=new Procs2(3,2);
    
    r = new BlockRange(10, q.dim(0)).subrng(6,6,-1);
    s = new BlockRange(4, p.dim(1));
	t = 12; //???
    // t = new Range(12);

    // Range r = new BlockRange(10, q.dim(0)).subrng(6,6,-1);
    // BlockRange s =new BlockRange(4, p.dim(1));
    // Range t = new Range(12);
    
    b = new Array3ddcI(q, r, s, t);

    Array1dI u = new Array1dI(q, r);
    Array1cI v = new Array1cI(q, t);

    if (p.on()) {
      ix = new Index (x);
      // iy = new Index (y); // ???
      iz = new Index (z);

      ix.dim().over();
      for (ix.begin(); ix.test(); ix.next()) {
	// iy.dim().over();
	// for (iy.begin(); iy.test(); iy.next()) {
	for(iy = 0; iy < y; iy++)
	  iz.dim().over();
	  for (iz.begin(); iz.test(); iz.next()) {
	    a.dat()[a.pos(ix,iy,iz)]= 100*x.idx(ix) + 10*(iy) + z.idx(iz);
	  } iz.dim().revo();
	// } iy.dim().revo();
      } ix.dim().revo();
    } p.no();

    if (q.on()) {
      ir = new Index (r);

      ir.dim().over();
      for (ir.begin(); ir.test(); ir.next()) {
		u.dat()[u.pos(ir)] = (r.idx(ir) * 5) % 8;
      } ir.dim().revo();
      
      // it = new Index (t);

      // it.dim().over();
      // for (it.begin(); it.test(); it.next()) {
	  for (it = 0; it < t; it ++)
	  	v.dat()[v.pos(it)] = it / 2 + 1;
      // } it.dim().revo();
    } q.no();

    Adlib.aprintf("%3R0%3R1%3R2%10d\n", b);

    spmd.finalize();

  }
}
 
